<?php
/*
 * @version $Id: hook.php 7355 2008-10-03 15:31:00Z moyo $
 ----------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copynetwork (C) 2003-2006 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org/
 ----------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 ------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: Remi Collet
// Purpose of file: Hook for the webservices plugin
// ----------------------------------------------------------------------

include_once ("inc/plugin_webservices.classes.php");
include_once ("inc/plugin_webservices.functions.php");
include_once ("inc/plugin_webservices.session.php");


// Define search option for types of the plugins
function plugin_webservices_getSearchOption(){
	global $LANG;
	$sopt=array();

	// Part header
	$sopt[PLUGIN_WEBSERVICES_TYPE]['common']=$LANG["webservices"][0];

	$sopt[PLUGIN_WEBSERVICES_TYPE][1]['table']='glpi_plugin_webservices';
	$sopt[PLUGIN_WEBSERVICES_TYPE][1]['field']='name';
	$sopt[PLUGIN_WEBSERVICES_TYPE][1]['linkfield']='name';
	$sopt[PLUGIN_WEBSERVICES_TYPE][1]['name']=$LANG["common"][16];
	$sopt[PLUGIN_WEBSERVICES_TYPE][1]['datatype']='itemlink';

	$sopt[PLUGIN_WEBSERVICES_TYPE][3]['table']='glpi_plugin_webservices';
	$sopt[PLUGIN_WEBSERVICES_TYPE][3]['field']='comments';
	$sopt[PLUGIN_WEBSERVICES_TYPE][3]['linkfield']='comments';
	$sopt[PLUGIN_WEBSERVICES_TYPE][3]['name']=$LANG["common"][25];
	$sopt[PLUGIN_WEBSERVICES_TYPE][3]['datatype']='text';

	$sopt[PLUGIN_WEBSERVICES_TYPE][8]['table']='glpi_plugin_webservices';
	$sopt[PLUGIN_WEBSERVICES_TYPE][8]['field']='active';
	$sopt[PLUGIN_WEBSERVICES_TYPE][8]['linkfield']='active';
	$sopt[PLUGIN_WEBSERVICES_TYPE][8]['name']=$LANG["webservices"][1];
	$sopt[PLUGIN_WEBSERVICES_TYPE][8]['datatype']='bool';

	$sopt[PLUGIN_WEBSERVICES_TYPE][9]['table']='glpi_plugin_webservices';
	$sopt[PLUGIN_WEBSERVICES_TYPE][9]['field']='do_log';
	$sopt[PLUGIN_WEBSERVICES_TYPE][9]['linkfield']='do_log';
	$sopt[PLUGIN_WEBSERVICES_TYPE][9]['name']=$LANG["webservices"][6];

   $sopt[PLUGIN_WEBSERVICES_TYPE][10]['table']='glpi_plugin_webservices';
   $sopt[PLUGIN_WEBSERVICES_TYPE][10]['field']='deflate';
   $sopt[PLUGIN_WEBSERVICES_TYPE][10]['linkfield']='deflate';
   $sopt[PLUGIN_WEBSERVICES_TYPE][10]['name']=$LANG["webservices"][9];
   $sopt[PLUGIN_WEBSERVICES_TYPE][10]['datatype']='bool';

	$sopt[PLUGIN_WEBSERVICES_TYPE][13]['table']='glpi_plugin_webservices';
	$sopt[PLUGIN_WEBSERVICES_TYPE][13]['field']='ip';
	$sopt[PLUGIN_WEBSERVICES_TYPE][13]['linkfield']='ip';
	$sopt[PLUGIN_WEBSERVICES_TYPE][13]['name']=$LANG["networking"][14];

	$sopt[PLUGIN_WEBSERVICES_TYPE][17]['table']='glpi_plugin_webservices';
	$sopt[PLUGIN_WEBSERVICES_TYPE][17]['field']='pattern';
	$sopt[PLUGIN_WEBSERVICES_TYPE][17]['linkfield']='pattern';
	$sopt[PLUGIN_WEBSERVICES_TYPE][17]['name']=$LANG["webservices"][2];


	return $sopt;
}

function plugin_webservices_registerMethods() {
   global $WEBSERVICES_METHOD;

   // Not authenticated method
   $WEBSERVICES_METHOD['glpi.test']='plugin_webservices_method_test';
   $WEBSERVICES_METHOD['glpi.status']='plugin_webservices_method_status';
   $WEBSERVICES_METHOD['glpi.listAllMethods']='plugin_webservices_method_list';
   $WEBSERVICES_METHOD['glpi.listEntities']='plugin_webservices_method_listEntities';
   $WEBSERVICES_METHOD['glpi.doLogin']='plugin_webservices_method_doLogin';

   // Authenticated method - Session
   $WEBSERVICES_METHOD['glpi.doLogout']='plugin_webservices_method_doLogout';
   $WEBSERVICES_METHOD['glpi.getMyInfo']='plugin_webservices_method_getMyInfo';
   $WEBSERVICES_METHOD['glpi.listMyProfiles']='plugin_webservices_method_listMyProfiles';
   $WEBSERVICES_METHOD['glpi.setMyProfile']='plugin_webservices_method_setMyProfile';
   $WEBSERVICES_METHOD['glpi.listMyEntities']='plugin_webservices_method_listMyEntities';
   $WEBSERVICES_METHOD['glpi.setMyEntity']='plugin_webservices_method_setMyEntity';

   // Authenticated method - Others
   $WEBSERVICES_METHOD['glpi.listDropdownValues']='plugin_webservices_method_listDropdownValues';
   $WEBSERVICES_METHOD['glpi.listGroups']='plugin_webservices_method_listGroups';
   $WEBSERVICES_METHOD['glpi.listHelpdeskTypes']='plugin_webservices_method_listHelpdeskTypes';
   $WEBSERVICES_METHOD['glpi.listHelpdeskItems']='plugin_webservices_method_listHelpdeskItems';
   $WEBSERVICES_METHOD['glpi.listTickets']='plugin_webservices_method_listTickets';
   $WEBSERVICES_METHOD['glpi.listUsers']='plugin_webservices_method_listUsers';

   $WEBSERVICES_METHOD['glpi.getTicket']='plugin_webservices_method_getTicket';
   $WEBSERVICES_METHOD['glpi.getComputer']='plugin_webservices_method_getComputer';
   $WEBSERVICES_METHOD['glpi.getComputerInfoComs']='plugin_webservices_method_getComputerInfoComs';
   $WEBSERVICES_METHOD['glpi.getComputerContracts']='plugin_webservices_method_getComputerContracts';
   $WEBSERVICES_METHOD['glpi.getDocument']='plugin_webservices_method_getDocument';
   $WEBSERVICES_METHOD['glpi.listComputers']='plugin_webservices_method_listComputers';
   $WEBSERVICES_METHOD['glpi.listInventoryObjects']='plugin_webservices_method_listInventoryObjects';

   $WEBSERVICES_METHOD['glpi.createTicket']='plugin_webservices_method_createTicket';
   $WEBSERVICES_METHOD['glpi.addTicketFollowup']='plugin_webservices_method_addTicketFollowup';
   $WEBSERVICES_METHOD['glpi.addTicketDocument']='plugin_webservices_method_addTicketDocument';
}

function plugin_webservices_giveItem($type,$ID,$data,$num){
   global $CFG_GLPI, $INFOFORM_PAGES, $LANG,$SEARCH_OPTION,$LINK_ID_TABLE,$DB;

   $table=$SEARCH_OPTION[$type][$ID]["table"];
   $field=$SEARCH_OPTION[$type][$ID]["field"];

   switch ($table.'.'.$field){
      case "glpi_plugin_webservices.do_log":
            switch ($data["ITEM_$num"]) {
               case 2:
                  return $LANG['Menu'][30];
                  break;
               case 1:
                  return $LANG['title'][38];
                  break;
               default:
                  return $LANG['choice'][0];
            }
         break;
   }
}

function plugin_webservices_addSelect($type,$ID,$num) {
	global $SEARCH_OPTION;

	$table=$SEARCH_OPTION[$type][$ID]["table"];
	$field=$SEARCH_OPTION[$type][$ID]["field"];

	switch ($field) {
		case 'ip':
			return " CONCAT(INET_NTOA(ip_start), ' - ', INET_NTOA(ip_end)) AS ITEM_$num, ";
			break;
	}
	return '';
}
function plugin_webservices_addWhere($link,$nott,$type,$ID,$val) {
	global $SEARCH_OPTION;

	$NOT = ($nott ? " NOT" : "");

	$table=$SEARCH_OPTION[$type][$ID]["table"];
	$field=$SEARCH_OPTION[$type][$ID]["field"];

	switch ($field) {
		case 'ip':
			return " $link $NOT ( INET_ATON('$val')>=ip_start AND INET_ATON('$val')<=ip_end ) ";
			break;
		case 'pattern':
			return " $link '$val' $NOT REGEXP pattern ";
			break;
	}
	return '';
}
function plugin_webservices_addOrderBy($type,$ID,$order,$key=0){
	global $SEARCH_OPTION;

	$table=$SEARCH_OPTION[$type][$ID]["table"];
	$field=$SEARCH_OPTION[$type][$ID]["field"];

	switch ($field) {
		case 'ip':
			return " ORDER BY ip_start $order, ip_end $order ";
			break;
	}
	return '';
}

function cron_plugin_webservices() {
	logInFile('webservices',"cron called\n");
   plugin_webservices_soap_create_wdsl();
   return 1;
}
?>