<?php
/*
 * @version $Id: phone.php 7762 2009-01-06 18:30:32Z moyo $
 -------------------------------------------------------------------------
 GLPI - Gestionnaire Libre de Parc Informatique
 Copyright (C) 2003-2009 by the INDEPNET Development Team.

 http://indepnet.net/   http://glpi-project.org
 -------------------------------------------------------------------------

 LICENSE

 This file is part of GLPI.

 GLPI is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.

 GLPI is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with GLPI; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 --------------------------------------------------------------------------
 */

// ----------------------------------------------------------------------
// Original Author of file: Remi Collet
// Purpose of file: Manage list of config
// ----------------------------------------------------------------------
if (!function_exists("xmlrpc_encode")) {
   header("HTTP/1.0 500 Extension xmlrpc not loaded");
   die("Extension xmlrpc not loaded");
}

define('GLPI_ROOT', '../..');

// define session_id before any other think
if (isset($_GET['session'])) {
   include_once ("inc/plugin_webservices.session.php");
   plugin_webservices_setSession($_GET['session']);
}

$NEEDED_ITEMS = array('computer', 'document', 'enterprise', 'entity', 'group', 'infocom',
   'monitor', 'networking', 'ocsng', 'peripheral', 'phone', 'planning', 'printer', 'profile',
   'rulesengine', 'rule.right', 'rule.tracking', 'setup', 'software', 'tracking', 'user');

include (GLPI_ROOT . "/inc/includes.php");

usePlugin('webservices', true);

doHook("webservices");
plugin_webservices_registerMethods();

error_reporting(E_ALL);

if ($_SERVER["CONTENT_TYPE"] != "text/xml") {
   header("HTTP/1.0 500 Bad content type");
   die("Bad content type");
}

if (!isset($GLOBALS["HTTP_RAW_POST_DATA"]) || empty($GLOBALS["HTTP_RAW_POST_DATA"])) {
   header("HTTP/1.0 500 No content");
}

$method="";
$allparams=xmlrpc_decode_request($GLOBALS["HTTP_RAW_POST_DATA"],$method,'UTF-8');

if (empty($method) || !is_array($allparams)) {
   header("HTTP/1.0 500 Bad content");
}

$params=(isset($allparams[0]) && is_array($allparams[0]) ? $allparams[0] : array());

$resp = plugin_webservice_execute($method,$params,WEBSERVICE_PROTOCOL_XMLRPC);

header("Content-type: text/xml");

// request without method is a response ;)
echo xmlrpc_encode_request(NULL,$resp,array('encoding'=>'UTF-8'));

?>
